Summary:	The GNU core utilities: a set of tools commonly used in shell scripts
Name:		coreutils
Version:	8.12
Release:	%mkrel 1
License:	GPLv3+
Group:		System/Base
Url:		http://www.gnu.org/software/coreutils/
Source0:	http://ftp.gnu.org/gnu/%{name}/%{name}-%{version}.tar.xz
Source200:	su.pamd
Source202:	su-l.pamd

# fileutils
Patch101:	coreutils-8.2-spacedir.patch
Patch1155:	coreutils-8.2-force-option--override--interactive-option.patch
Patch118:	fileutils-4.1-ls_h.patch
Patch500:	coreutils-8.3-mem.patch

# sh-utils

#add info about TZ envvar to date manpage
Patch703:	coreutils-6.11-dateman.patch
#set paths for su explicitly, don't get influenced by paths.h
Patch704:	sh-utils-1.16-paths.patch
# RMS will never accept the PAM patch because it removes his historical
# rant about Twenex and the wheel group, so we'll continue to maintain
# it here indefinitely.
Patch706:	coreutils-8.7-pam.patch
Patch713:	coreutils-4.5.3-langinfo.patch

# (sb) lin18nux/lsb compliance - normally from here:
# http://www.openi18n.org/subgroups/utildev/patch/
# this one is actually a merger of 5.2 and 5.3, as join segfaults
# compiled with gcc4 and the 5.1/5.2 patch
# fwang: we often get this patch from fedora
Patch800:	coreutils-8.10-new-i18n.patch

Patch909:	coreutils-5.1.0-64bit-fixes.patch

# https://qa.mandriva.com/show_bug.cgi?id=38577
Patch911:	coreutils-8.3-groupfix.patch

Patch1011:	coreutils-8.9-DIR_COLORS-mdkconf.patch
#(peroyvind): add back always red blinking on broken symlinks
Patch1013:	coreutils-8.2-always-blinking-colors-on-broken-symlinks.patch
#(peroyvind): fix a test that fails to compile with -Werror=format-security
Patch1014:	coreutils-8.8-check-string-format.patch

# fedora patches
#add note about no difference between binary/text mode on Linux - md5sum manpage
Patch2101:	coreutils-8.9-manpages.patch
#temporarily workaround probable kernel issue with TCSADRAIN(#504798)
Patch2102:	coreutils-7.4-sttytcsadrain.patch
#do display processor type for uname -p/-i based on uname(2) syscall
Patch2103:	coreutils-8.2-uname-processortype.patch
#df --direct
Patch2104:	coreutils-8.9-df-direct.patch
#Fix mkstemp on sparc64
Patch2105:	coreutils-mkstemp.patch

#Call setsid() in su under some circumstances (bug #173008).
Patch2900:	coreutils-setsid.patch
#make runuser binary based on su.c
Patch2907:	coreutils-8.7-runuser.patch
#getgrouplist() patch from Ulrich Drepper.
Patch2908:	coreutils-getgrouplist.patch
#Prevent buffer overflow in who(1) (bug #158405).
Patch2912:	coreutils-overflow.patch
#compile su with pie flag and RELRO protection
Patch2917:	coreutils-8.4-su-pie.patch

BuildRequires:	gettext
BuildRequires:	termcap-devel
BuildRequires:	pam-devel
BuildRequires:	texinfo >= 4.3
# We need automake which supports the dist-xz target
BuildRequires:	automake >= 1.10.2-2
# And tar which supports xz automagically since rpm.org seems to rely on this(..?)
BuildRequires:	tar >= 1.21-2
BuildRequires:	libacl-devel
BuildRequires:	libattr-devel
BuildRequires:	libgmp-devel
BuildRequires:	libcap-devel
BuildRequires:	bison
BuildRequires:	flex
BuildRequires:	strace

Provides:	mktemp = %{version}
Obsoletes:	mktemp < %{version}

Provides:	stat = %{version}
Provides:	%{_bindir}/env
Provides:	/bin/env
Obsoletes:	base64
Conflicts:	tetex < 1.0.7-49mdk
BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot

%description
This package is the union of the old GNU fileutils, sh-utils, and 
textutils packages.

These tools are the GNU versions of common useful and popular
file & text utilities which are used for:
- file management
- shell scripts
- modifying text file (spliting, joining, comparing, modifying, ...)

Most of these programs have significant advantages over their Unix
counterparts, such as greater speed, additional options, and fewer
arbitrary limits.

%package	doc
Summary:	Coreutils documentation in info format
Group:		Books/Computer books
Requires:	coreutils >= 4.5.4-2mdk
Requires(post,preun):	info-install
BuildArch:	noarch

%description	doc
This package contains coreutils documentation in GNU info format.

%prep
%setup -q

# fileutils
# (tpg) seems to be fixed
#%patch101 -p1 -b .space~
%patch1155 -p1 -b .override~
%patch118 -p1

# textutils
%patch500 -p1

# sh-utils
%patch703 -p1 -b .dateman~
%patch704 -p1 -b .paths~
%patch706 -p1 -b .pam~
%patch713 -p1 -b .langinfo~

# li18nux/lsb
%patch800 -p1 -b .i18n~

%patch909 -p1 -b .64bit~
%patch911 -p1 -b .groups~

%patch1011 -p1 -b .colors_mdkconf~
%patch1013 -p1 -b .broken_blink~
%patch1014 -p1 -b .str_fmt~

%patch2101 -p1 -b .manpages~
%patch2102 -p1 -b .tcsadrain~
%patch2103 -p1 -b .sysinfo~
# (tpg) not needed for now
#%patch2104 -p1 -b .dfdirect~
%patch2105 -p1 -b .sparc~

%patch2900 -p1 -b .setsid~
%patch2907 -p1 -b .runuser~
%patch2908 -p1 -b .getgrouplist~
%patch2912 -p1 -b .overflow~
%patch2917 -p1 -b .pie~

chmod a+x tests/misc/sort-mb-tests tests/misc/id-context
chmod +w ./src/dircolors.h
./src/dcgen ./src/dircolors.hin > ./src/dircolors.h

export DEFAULT_POSIX2_VERSION=199209
aclocal -I m4
automake --gnits --add-missing
autoconf
bzip2 -9 ChangeLog

%build
export CFLAGS="%{optflags} -fPIC -D_GNU_SOURCE=1"

%configure2_5x \
	--enable-largefile \
	--enable-pam \
	--enable-install-program=su \
	--enable-no-install-program=arch,hostname,uptime,kill \
	--without-selinux \
	--disable-rpath \
	--disable-silent-rules

%make

%check
%make check

%install
rm -rf %{buildroot}
%makeinstall_std

# man pages are not installed with make install
make mandir=%{buildroot}%{_mandir} install-man

# let be compatible with old fileutils, sh-utils and textutils packages :
mkdir -p %{buildroot}{/bin,%{_bindir},%{_sbindir},%{_sysconfdir}/pam.d}
for f in basename cat chgrp chmod chown cp cut date dd df echo env expr false id link ln ls mkdir mknod mktemp mv nice pwd rm rmdir sleep sort stat stty sync touch true uname unlink tac
do
	mv %{buildroot}/{%{_bindir},bin}/$f
done

# chroot was in /usr/sbin :
mv %{buildroot}/{%{_bindir},%{_sbindir}}/chroot
# {cat,sort,cut} were previously moved from bin to /usr/bin and linked into 
for f in cut env expr tac; do
	ln -s /bin/$f %{buildroot}%{_bindir}/$f
done

install -m644 src/dircolors.hin -D %{buildroot}%{_sysconfdir}/DIR_COLORS

# su
install -m 4755 src/su %{buildroot}/bin

install -m 644 %{SOURCE200} %{buildroot}%{_sysconfdir}/pam.d/su
install -m 644 %{SOURCE202} %{buildroot}%{_sysconfdir}/pam.d/su-l

#TV# find_lang look for LC_MESSAGES, not LC_TIME:
find %{buildroot}%{_datadir}/locale/ -name coreutils.mo | fgrep LC_TIME | xargs rm -f
%find_lang %{name}

%clean
rm -rf %{buildroot}

%preun doc
%_remove_install_info %{name}.info

%post doc
%_install_info %{name}.info
# The next true is needed: else, if there's a problem, the 
# package'll be installed 2 times because of trigger faillure
true

%files -f %{name}.lang
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/D*
%config(noreplace) %{_sysconfdir}/pam.d/su
%config(noreplace) %{_sysconfdir}/pam.d/su-l
%doc README
/bin/*
%{_bindir}/*
%{_sbindir}/chroot
%dir %{_libdir}/coreutils
%{_libdir}/coreutils/libstdbuf.so

%files doc
%defattr(-,root,root)
%doc ABOUT-NLS ChangeLog.bz2 NEWS THANKS TODO
%{_infodir}/coreutils*
%{_mandir}/man*/*


%changelog
* Sun Jun 19 2011 Tomasz Pawel Gajc <tpg@mandriva.org> 8.12-1mdv2011.0
+ Revision: 686061
- update to new version 8.12

* Wed Apr 20 2011 Tomasz Pawel Gajc <tpg@mandriva.org> 8.11-1
+ Revision: 656350
- update to new version 8.11
- disable patches 101 and 2104
- update to new version 8.10
- update patch 800

  + Per Øyvind Karlsen <peroyvind@mandriva.org>
    - add '.gem' suffix with same color as other arhives with 'ls'

* Tue Jan 18 2011 Per Øyvind Karlsen <peroyvind@mandriva.org> 8.9-2
+ Revision: 631565
- remove unnecessary buildrequires on locales-*
- remove dependency on pam causing dependency loop
- add back LC_TIME workaround for %%find_lang for now as it breaks upgrades..

* Sun Jan 09 2011 Per Øyvind Karlsen <peroyvind@mandriva.org> 8.9-1mdv2011.0
+ Revision: 630708
- let %%find_lang take care of LC_TIME locale symlinks now
- new release: 8.9

* Wed Dec 29 2010 Per Øyvind Karlsen <peroyvind@mandriva.org> 8.8-1mdv2011.0
+ Revision: 625742
- license is actually GPLv3+, not GPLv3.. ;p
- drop old patches
- don't install kill(1), it's provided by util-linux
- create all symlinks from /bin/ to /usr/bin in one and same loop
- drop no longer required fix for japanese catalog file
- be sure to own %%{_libdir}/coreutils directory
- fix check that fails to compile with -Werror=format-security (P1014)
- use included help2man
- sync patches with coreutils-8.8-1 from fedora
- sh-utils, fileutils & textutils merge with corresponding provides/obsoletes
  dates back to 2002, so we can prolly' safely drop these now... ;)
- new release: 8.8
- pass '--disable-silent-rules' to configure, build output is nice for build logs
- configure not to install 'hostname' & 'uptime' in %%build, rather than removing
  those in %%install
- do autofoo in %%prep
- remove perl regexp on texinfo page for wtmp path, now giving duplicate..
- compress ChangeLog in %%prep and drop shipping ancient changelogs
- explicitly build without selinux support
- obsolete/provide mktemp

* Tue Nov 16 2010 Bogdano Arendartchuk <bogdano@mandriva.com> 8.7-3mdv2011.0
+ Revision: 598126
- replacing ealier release uploaded manually

  + Andrey Borzenkov <arvidjaar@mandriva.org>
    - source202: su -l PAM config (fedora)

* Tue Nov 16 2010 Funda Wang <fwang@mandriva.org> 8.7-1mdv2011.0
+ Revision: 598011
- new version 8.7

  + Tomasz Pawel Gajc <tpg@mandriva.org>
    - update to new version 8.6
    - update patches 706 and 800 (from Fedora)

* Tue Aug 31 2010 Thierry Vignaud <tv@mandriva.org> 8.5-2mdv2011.0
+ Revision: 574911
- let the doc subpackage be noarch

* Thu Apr 29 2010 Funda Wang <fwang@mandriva.org> 8.5-1mdv2010.1
+ Revision: 540892
- New version 8.5

* Tue Feb 09 2010 Funda Wang <fwang@mandriva.org> 8.4-2mdv2010.1
+ Revision: 502813
- rebuild for new gmp

* Thu Jan 14 2010 Funda Wang <fwang@mandriva.org> 8.4-1mdv2010.1
+ Revision: 491125
- add several BRs for locales
- new version 8.4

* Mon Jan 11 2010 Funda Wang <fwang@mandriva.org> 8.3-1mdv2010.1
+ Revision: 489498
- no tests needed to be disabled
- rediff i18n patch
- rediff some patches
- New version 8.3

* Sun Jan 03 2010 Funda Wang <fwang@mandriva.org> 8.2-1mdv2010.1
+ Revision: 485787
- disable utimens too
- disable tests which introduce assertion (unknown reason)
- disable format check in check section
- rediff spacedir patch
- New version 8.2
- drop touch_errno patch (don't know where it comes and does not apply)
- renew uname patch with fedora one
- rediff patches

* Fri Oct 16 2009 Frederic Crozat <fcrozat@mandriva.com> 7.5-2mdv2010.0
+ Revision: 457931
- Move tac to /bin, needed for latest initscripts

* Sun Aug 23 2009 Tomasz Pawel Gajc <tpg@mandriva.org> 7.5-1mdv2010.0
+ Revision: 419994
- add missing buildrequires on strace, bison, flex, libcap-devel and libgmp-devel
- spec file clean
- rediff patches 800, 1011 and 1013
- disable rpath
- fix license
- package libstdbuf.so

  + Nicolas Lécureuil <nlecureuil@mandriva.com>
    - Add su manpage (Bug #51699)

* Mon Jul 20 2009 Guillaume Rousse <guillomovitch@mandriva.org> 7.4-2mdv2010.0
+ Revision: 398210
- re-activate utimensat, now the xen kernel is uptodate

* Tue May 19 2009 Guillaume Rousse <guillomovitch@mandriva.org> 7.4-1mdv2010.0
+ Revision: 377815
- new version

  + Thierry Vignaud <tv@mandriva.org>
    - new version

* Sat May 02 2009 Funda Wang <fwang@mandriva.org> 7.2-1mdv2010.0
+ Revision: 370446
- New version 7.2

* Thu Mar 05 2009 Frederic Crozat <fcrozat@mandriva.com> 7.1-2mdv2009.1
+ Revision: 349061
- Add explicit provides for /bin/env and /usr/bin/env

* Thu Feb 26 2009 Per Øyvind Karlsen <peroyvind@mandriva.org> 7.1-1mdv2009.1
+ Revision: 345271
- add versioned buildrequires on tar & automake for xz support
- new release: 7.1
- rediff a lot of patches..
- fix typo
- update DIR_COLORS patch with new .xz format added

  + Tomasz Pawel Gajc <tpg@mandriva.org>
    - rebuild for python-2.6

* Sun Dec 21 2008 Oden Eriksson <oeriksson@mandriva.com> 6.12-4mdv2009.1
+ Revision: 316959
- rediffed some fuzzy patches

* Tue Nov 11 2008 Gustavo De Nardin <gustavodn@mandriva.com> 6.12-3mdv2009.1
+ Revision: 302337
- cripple coreutils to not use utimensat() syscall, available since kernel
  2.6.22, for Xen kernel compatibility (#45606)

  + Thierry Vignaud <tv@mandriva.org>
    - remove tool list from description

* Tue Jun 24 2008 Luiz Fernando Capitulino <lcapitulino@mandriva.com> 6.12-2mdv2009.0
+ Revision: 228635
- Fix wrong allocation size
  The line which allocates szStrings is allocating only
  three bytes instead of the space required for three
  char pointers.
  Bug reproducible by doing 'uname -p'.

* Mon Jun 16 2008 Funda Wang <fwang@mandriva.org> 6.12-1mdv2009.0
+ Revision: 219518
- fix problematic cut test case
- chmod at prep section
- New version 6.12
- sync i18n patch with fedora

* Thu May 01 2008 Funda Wang <fwang@mandriva.org> 6.11-1mdv2009.0
+ Revision: 199891
- rediff groupfix patch
- rediff i18n and pam patch
- rediff patch703
- New version 6.11

* Fri Mar 07 2008 Andreas Hasenack <andreas@mandriva.com> 6.10-4mdv2008.1
+ Revision: 181646
- drop specific versioned requires of automake
- fix "id" can't fetch group name (#38577)

* Tue Jan 29 2008 Funda Wang <fwang@mandriva.org> 6.10-3mdv2008.1
+ Revision: 159680
- fix requirment on info-install

* Sun Jan 27 2008 Funda Wang <fwang@mandriva.org> 6.10-2mdv2008.1
+ Revision: 158552
- update binary list

* Sat Jan 26 2008 Funda Wang <fwang@mandriva.org> 6.10-1mdv2008.1
+ Revision: 158248
- Update i18n patch with fedora one
- rediff uname patch
- rediff pam patch
- New version 6.10
- drop patches merged upstream

* Fri Jan 11 2008 Thierry Vignaud <tv@mandriva.org> 6.9-6mdv2008.1
+ Revision: 149129
- rebuild
- kill re-definition of %%buildroot on Pixel's request

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Arnaud Patard <apatard@mandriva.com>
    - Use proper way to change CFLAGS in the spec file.
      (aka dd if=/dev/zero bs=1M count=300 | time -p sum -s bug fix).

* Thu Sep 06 2007 Per Øyvind Karlsen <peroyvind@mandriva.org> 6.9-5mdv2008.0
+ Revision: 81114
- disable coloring for text documents

* Sun Aug 26 2007 Per Øyvind Karlsen <peroyvind@mandriva.org> 6.9-4mdv2008.0
+ Revision: 71568
- give black background for white text for documents in case of using
  terminal with white background (updates P1011, fixes #32827)
- add some more files to doc coloring (updates P1011)

* Thu Aug 23 2007 Thierry Vignaud <tv@mandriva.org> 6.9-3mdv2008.0
+ Revision: 69360
- kill file require on info-install

  + Per Øyvind Karlsen <peroyvind@mandriva.org>
    - add coloring for .wma & *rc (updates P1011)
    - add even more formats (updates P1011, I have no life:p)
    - drop lzma patch (P1010) and rather merge with generic dircolors patch (P1011)
    - add some more formats (updates P1011)
    - regenerate dircolors.h with dcgen in stead of patch
    - add coloring for backup files (updates P1011)
    - drop junk and be sure not to remove copyright notice in dircolors.hin (updates P1011)
    - add white color for document formats (updates P1011)
    - add a few more formats (updates P1011)
    - update P1011 with coloring for .flv (flash video)

* Sat Jul 14 2007 Funda Wang <fwang@mandriva.org> 6.9-2mdv2008.0
+ Revision: 51981
- Add fedora patch to build against glibc 2.6
- Update program list
- Obsoletes base64

  + Per Øyvind Karlsen <peroyvind@mandriva.org>
    - add back always blinking colors for broken symlinks (P1013)
    - fix P1011 as it reverted P1010 and lzma coloring

* Thu Jul 12 2007 Funda Wang <fwang@mandriva.org> 6.9-1mdv2008.0
+ Revision: 51465
- Enable test scripts
- Remove old acl patches
- rediff patch 1011
- Rediff patch 1010.
- Add patch1012: From fedora, fix ls -x
- Rediff patch800: from fedora
- Rediff patch706: from Fedora.
- Rediff patch1155
- remove patch107: obsoletes by upstream code
- Remove patch102: sparc detection not there
- Remove patch0: lg.po not there
- New upstream version

* Wed Jul 11 2007 Per Øyvind Karlsen <peroyvind@mandriva.org> 5.97-8mdv2008.0
+ Revision: 51341
- drop S101 & S102 and rather merge with dircolors.hin in package as well as add few types (P1011)
- add lzma coloring support for ls (P1010, might need some more work?)
- change to and fix usage of new automake 1.10
- fix inclusion of locale files

* Mon May 28 2007 Ademar de Souza Reis Jr <ademar@mandriva.com.br> 5.97-7mdv2008.0
+ Revision: 32177
+ rebuild (emptylog)

* Mon May 28 2007 Ademar de Souza Reis Jr <ademar@mandriva.com.br> 5.97-6mdv2008.0
+ Revision: 32036
- fix -doc description
- remove redundant build-requirement of acl-devel

  + Anssi Hannula <anssi@mandriva.org>
    - fix URL


* Tue Feb 20 2007 Thierry Vignaud <tvignaud@mandriva.com> 5.97-6mdv2007.0
+ Revision: 123126
- bump release (#28834)

  + Per Øyvind Karlsen <pkarlsen@mandriva.com>
    - reintroduce interactive override (-if) and rather fix check (P1155, real fix for #16209)

  + Olivier Blin <oblin@mandriva.com>
    - explicitely run autotools (or else configure is run two times), we need them for pam/i18n/acl/xattr/hname

* Fri Oct 20 2006 Olivier Blin <oblin@mandriva.com> 5.97-4mdv2007.1
+ Revision: 71290
- rebuild for su to be linked with pam (#26353 and #26527)
- Import coreutils

* Thu Aug 31 2006 Thierry Vignaud <tvignaud@mandriva.com> 5.97-3mdv2007.0
- kill patch 1155 thus the testsuite works again (#16209)
  [warning: this means cp -i -f behaves like cp -i, no more like cp -f]
- update & reenable patch 1001-1004 from suse (ACL+xattr support)

* Thu Aug 31 2006 Thierry Vignaud <tvignaud@mandriva.com> 5.97-1mdv2007.0
- new release
- update patches 800 & 1001 from rh
- rediff patches 101, 105, 111, 114, 1115, 703 & 1003
- kill patches 108, 112, 116, 117, 153, 908, 2000 (merged upstream)
- kill patch 2001 (no more needed)
- kill patch 105 (unstandard option)
- drop patches 111 (deprecated rh patch introduced in fileutils-4.1.1-1mdk),
  114 (likewise, 4.1) 115 (likewise, 4.1.5-1mdk), 710, 901 (no more needed),
  1002 (merged in 1001)
- source 200: sync with fedora
- disable patch 104 (it's time to catch offenders) and 1003 (broken)
- fix build

* Thu Aug 31 2006 Thierry Vignaud <tvignaud@mandriva.com> 5.2.1-11mdv2007.0
- patch 2000: update zh translation (#17302)
- patch 2001: fix build
- fix macro-in-%%changelog

* Sat May 13 2006 Stefan van der Eijk <stefan@eijk.nu> 5.2.1-10mdk
- rebuild for sparc

* Mon Jan 30 2006 Olivier Blin <oblin@mandriva.com> 5.2.1-9mdk
- use "include" directive instead of deprecated pam_stack module

* Fri Aug 19 2005 Stew Benedict <sbenedict@mandriva.com> 5.2.1-8mdk
- redo LSB/i18n patch, join segfaults during LSB testing 
  when compiled with gcc4

* Fri Aug 12 2005 Leonardo Chiquitto Filho <chiquitto@mandriva.com> 5.2.1-7mdk
- patches 1001, 1002 1003: add support to posix acls and extended attributes
  (#15050)
- patch 801: fix some typos in pt_BR.po file

* Fri Aug 12 2005 Nicolas Lcureuil <neoclust@mandriva.org> 5.2.1-6mdk
- fix rpmlint errors (PreReq)

* Thu Feb 10 2005 Thierry Vignaud <tvignaud@mandrakesoft.com> 5.2.1-5mdk
- move expr into /bin (#7052)

* Mon Jul 26 2004 Christiaan Welvaart <cjw@daneel.dyndns.org> 5.2.1-4mdk
- run automake for patch 111

* Fri Jun 25 2004 Thierry Vignaud <tvignaud@mandrakesoft.com> 5.2.1-3mdk
- simplify build

* Thu Jun 24 2004 Thierry Vignaud <tvignaud@mandrakesoft.com> 5.2.1-2mdk
- fix link with pam
- fix --short-circuit when %%build failled
- patch 910: show correct CPU name (Marcin Gondek, #7865)
  (if it brokes anything, we'll revert)
- patch 111: fix ls build

* Fri Apr 02 2004 Thierry Vignaud <tvignaud@mandrakesoft.com> 5.2.1-1mdk
- new release
- remove patch 502, 906 (useless)

